<?PHP

/*
   class.sejm.php - AGA na podstawie stron www Sejmu RP
   
   $Id: class.sejm.php,v 1.2 2006-02-27 21:50:48 kb Exp $

   This file is part of phpWikiBot
   Copyright (C) 2006 Krzysztof Burghardt.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include 'class.aga.php';

class Sejm extends Aga {
	private $imie;
	private $nazwisko;
	private $ur_rok, $ur_miesiac, $ur_dzien, $ur_miejsce;
	private $partia;
	private $numer;

	public function __construct($bodyURL, $templateURL) {
		parent::__construct($bodyURL, $templateURL);
		preg_match("/posel5\/(.+)\.htm/", $bodyURL, $matches);
		$this->numer = $matches[1];;
	}
	public function __destruct() {
		parent::__destruct();
	}

	private function searchData() {
		preg_match("/TITLE>Posel: (.+) /", $this->body, $matches);
		$this->imie = $matches[1];
		preg_match("/TITLE>Posel: $this->imie (.+)<\/TITLE/", $this->body, $matches);
		$this->nazwisko = $matches[1];
// DIMU
		preg_match("/B>Data i miejsce urodzenia: <\/B>(.+)<BR>/", $this->body, $matches);
		preg_match("/-.*-(.+),/", $matches[1], $dimu_matches);
		$this->ur_rok = $dimu_matches[1];
		preg_match("/-(.+)-/", $matches[1], $dimu_matches);
		$this->ur_miesiac = $dimu_matches[1];
		preg_match("/(.+)-.*-/", $matches[1], $dimu_matches);
		$this->ur_dzien = $dimu_matches[1];
		preg_match("/, (.+) /", $matches[1], $dimu_matches);
		$this->ur_miejsce = $dimu_matches[1];
// EoDIMU
		preg_match("/<B>Zawd: <\/B>(.+)\r/", $this->body, $matches);
		$this->zawod = $matches[1];
		preg_match("/Klub parlamentarny: <\/B><BR>Klub Parlamentarny (.+)\r/", $this->body, $matches);
		$this->partia = $matches[1];
	}
	public function logToConsole() {
		echo "imie: $this->imie\n";
		echo "nazwisko: $this->nazwisko\n";
		echo "ur_rok: $this->ur_rok\n";
		echo "ur_miesiac: $this->ur_miesiac\n";
		echo "ur_dzien: $this->ur_dzien\n";
		echo "ur_miejsce: $this->ur_miejsce\n";
		echo "zawod: $this->zawod\n";
		echo "partia: $this->partia\n";
		echo "\n";
	}
	private function request($rq) {
		echo "Odmien $rq, urodzon-y(-a) w: ";
		if(!defined("STDIN")) {
		        define("STDIN", "fopen('php://stdin','r')");
		}
		return trim(fread(STDIN, 1024));
	}
	public function makeTitle() {
		$this->getBody();
		$this->searchData();
//		$this->logToConsole();
		preg_match("/(.+) /", $this->imie, $matches);
                if (empty($matches[1])) {
		    $title = $this->imie . " " . $this->nazwisko;
		} else {
		    $title = $matches[1] . " " . $this->nazwisko;
		}
		return iconv("ISO-8859-2", "UTF-8", $title);
	}
	public function makeArticle() {
		$months = array(1=>'stycznia', 'lutego', 'marca', 'kwietnia',
			'maja', 'czerwca', 'lipca', 'sierpnia', 'wrzenia',
			'padziernika', 'listopada', 'grudnia');
		$partia_ = array('Platforma Obywatelska'=>'Platformy Obywatelskiej',
				 'Prawo i Sprawiedliwo'=>'Prawa i Sprawiedliwoci',
				 'Liga Polskich Rodzin'=>'Ligi Polskich Rodzin',
				 'Samoobrona Rzeczpospolitej Polskiej'=>'Samoobrony RP',
				 'Sojusz Lewicy Demokratyczne'=>'Sojuszu Lewicy Demokratycznej',
				 'Polskie Stronnictwo Ludowe'=>'Polskiego Stronnictwa Ludowego',
				 'Mniejszo Niemiecka'=>'Mniejszoci Niemieckiej');
		$this->getTemplate();
		$templateMarks = array("@@IMIE@@", "@@NAZWISKO@@", "@@UR_DZIEN@@", "@@UR_MIESIAC@@",
			"@@UR_ROK@@", "@@UR_MIEJSCE@@", "@@ZAWOD@@", "@@PARTIA@@", "@@PARTIA_@@",
			"@@UR_MIEJSCE_@@", "@@NUMER@@");
		$data = array($this->imie, $this->nazwisko, (int)$this->ur_dzien, $months[(int)$this->ur_miesiac],
			$this->ur_rok, $this->ur_miejsce, $this->zawod, $this->partia, $partia_[$this->partia],
			$this->request($this->ur_miejsce), $this->numer);
		$this->fillTemplate($templateMarks, $data);
		return $this->article;
	}
}

?>
